`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// module name:ALU-alu_4bit
//////////////////////////////////////////////////////////////////////////////////
module alu_4bit(op, a, b, CarryOut, ResultOut);
	
	input [2:0] op;
	input [3:0] a;
	input [3:0] b;
	output CarryOut;
	output [3:0] ResultOut;
	
	wire [2:0] Carry;
	
// module dac_alu1bit(op, Ain, Bin, CarryIn, ResultOut, CarryOut);
	alu1bit ALU0 (op, a[0], b[0], op[2], ResultOut[0], Carry[0]);
	alu1bit ALU1 (op, a[1], b[1], Carry[0], ResultOut[1], Carry[1]);
	alu1bit ALU2 (op, a[2], b[2], Carry[1], ResultOut[2], Carry[2]);
	alu1bit ALU3 (op, a[3], b[3], Carry[2], ResultOut[3], CarryOut);
	
endmodule
