`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Module Name:    dff_4bit 
// Revision 0.01 - File Created
//////////////////////////////////////////////////////////////////////////////////
module dff_4bit(clock, datain, dataout);
// input & output devices
    input 				clock;
	 input 	[3:0] 	datain;
	 output 	[3:0] 	dataout;

// create multiple instances of dff_1bit to create 4bit dff
	dff_1bit	D0	(clock, datain[0], dataout[0]);
	dff_1bit	D1	(clock, datain[1], dataout[1]);
	dff_1bit	D2	(clock, datain[2], dataout[2]);
	dff_1bit	D3	(clock, datain[3], dataout[3]);

endmodule
