`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Module Name:    BITADDER0.V 
//////////////////////////////////////////////////////////////////////////////////

module add1bit(Ain, Bin, Cin, Sum, CarryOut);
	
	input		Ain, Bin, Cin;
	output 	Sum, CarryOut;
	
	assign Sum 			= Ain^Bin^Cin;
	assign CarryOut 	= (Ain & Bin)|(Ain & Cin)|(Bin & Cin);

endmodule
