`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Module Name:    mux4to1condition_v 
//////////////////////////////////////////////////////////////////////////////////
module MUX4to1(SEL, A,B,C,D, MUX_OUT);

	input [1:0] SEL;
   input A,B,C,D;
   output reg MUX_OUT;
   
	always @(SEL, A, B, C, D)
      case (SEL)
         2'b00: MUX_OUT = A;
         2'b01: MUX_OUT = B;
         2'b10: MUX_OUT = C;
         2'b11: MUX_OUT = D;
      endcase
					
endmodule
